package com.fp.persistence.plog.log;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TLOGLOAD*/
@Entity(name="TlogLoad")
@Table(name="TLOGLOAD")
public class TlogLoad extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TlogLoad
*/
@EmbeddedId
private TlogLoadKey pk;
@Column(name="LOADID", nullable=true)

/**
* Id de la carga, puede ser el codigo de persona, numero de lote, numero de cuenta.
*/
private String loadid;

@Column(name="STATUS", nullable=true)

/**
* Status de ejecucion de la carga P en proceso, E error, S  sucessfull
*/
private String status;

@Column(name="ADITIONALDATA", nullable=true)

/**
* Texto libre 
*/
private String aditionaldata;

/**Contructor por defecto*/
public TlogLoad(){
}
/**Contructor de TlogLoad
@param pPk Clave Primaria del entity
*/
public TlogLoad(TlogLoadKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TlogLoad
*/
public static TlogLoad find(EntityManager pEntityManager,TlogLoadKey pKey) throws Exception{
    TlogLoad obj = pEntityManager.find(TlogLoad.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TlogLoad
@return El objeto que referencia a la Clave primaria de TlogLoad
*/
public TlogLoadKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TlogLoad
@param pPk El objeto que referencia a la nueva Clave primaria de TlogLoad
*/
public void setPk(TlogLoadKey pPk){
  pk=pPk;
}
/**Obtiene el valor de loadid
@return valor de loadid*/
public String getLoadid(){
  return loadid;
}
/**Fija el valor de loadid
@param pLoadid nuevo Valor de loadid*/
public void setLoadid(String pLoadid){
  loadid=pLoadid;
}

/**Obtiene el valor de status
@return valor de status*/
public String getStatus(){
  return status;
}
/**Fija el valor de status
@param pStatus nuevo Valor de status*/
public void setStatus(String pStatus){
  status=pStatus;
}

/**Obtiene el valor de aditionaldata
@return valor de aditionaldata*/
public String getAditionaldata(){
  return aditionaldata;
}
/**Fija el valor de aditionaldata
@param pAditionaldata nuevo Valor de aditionaldata*/
public void setAditionaldata(String pAditionaldata){
  aditionaldata=pAditionaldata;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TlogLoad))return false;
    TlogLoad that = (TlogLoad) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad TlogLoad
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco TlogLoad
*/
public Object createInstance(){
 TlogLoad instance=new TlogLoad();	
 instance.setPk(new TlogLoadKey());
 return instance;
}
/**Clona la entidad TlogLoad
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TlogLoad p=(TlogLoad)this.clone();
  p.setPk((TlogLoadKey)this.pk.cloneMe());
  return p;
}
}
